// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_msgs:msg/ActionID.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__ACTION_ID__STRUCT_H_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__ACTION_ID__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'originating_station_id'
#include "etsi_its_denm_msgs/msg/detail/station_id__struct.h"
// Member 'sequence_number'
#include "etsi_its_denm_msgs/msg/detail/sequence_number__struct.h"

/// Struct defined in msg/ActionID in the package etsi_its_denm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_msgs__msg__ActionID
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// ActionID ::= SEQUENCE {
  ///     originatingStationID StationID,
  ///     sequenceNumber SequenceNumber
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_msgs__msg__StationID originating_station_id;
  etsi_its_denm_msgs__msg__SequenceNumber sequence_number;
} etsi_its_denm_msgs__msg__ActionID;

// Struct for a sequence of etsi_its_denm_msgs__msg__ActionID.
typedef struct etsi_its_denm_msgs__msg__ActionID__Sequence
{
  etsi_its_denm_msgs__msg__ActionID * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_msgs__msg__ActionID__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__ACTION_ID__STRUCT_H_
