// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_msgs:msg/SituationContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__SITUATION_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__SITUATION_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_msgs/msg/detail/situation_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'information_quality'
#include "etsi_its_denm_msgs/msg/detail/information_quality__traits.hpp"
// Member 'event_type'
// Member 'linked_cause'
#include "etsi_its_denm_msgs/msg/detail/cause_code__traits.hpp"
// Member 'event_history'
#include "etsi_its_denm_msgs/msg/detail/event_history__traits.hpp"

namespace etsi_its_denm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SituationContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: information_quality
  {
    out << "information_quality: ";
    to_flow_style_yaml(msg.information_quality, out);
    out << ", ";
  }

  // member: event_type
  {
    out << "event_type: ";
    to_flow_style_yaml(msg.event_type, out);
    out << ", ";
  }

  // member: linked_cause
  {
    out << "linked_cause: ";
    to_flow_style_yaml(msg.linked_cause, out);
    out << ", ";
  }

  // member: linked_cause_is_present
  {
    out << "linked_cause_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_cause_is_present, out);
    out << ", ";
  }

  // member: event_history
  {
    out << "event_history: ";
    to_flow_style_yaml(msg.event_history, out);
    out << ", ";
  }

  // member: event_history_is_present
  {
    out << "event_history_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_history_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SituationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: information_quality
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "information_quality:\n";
    to_block_style_yaml(msg.information_quality, out, indentation + 2);
  }

  // member: event_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_type:\n";
    to_block_style_yaml(msg.event_type, out, indentation + 2);
  }

  // member: linked_cause
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_cause:\n";
    to_block_style_yaml(msg.linked_cause, out, indentation + 2);
  }

  // member: linked_cause_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linked_cause_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.linked_cause_is_present, out);
    out << "\n";
  }

  // member: event_history
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_history:\n";
    to_block_style_yaml(msg.event_history, out, indentation + 2);
  }

  // member: event_history_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_history_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.event_history_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SituationContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_msgs::msg::SituationContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_msgs::msg::SituationContainer & msg)
{
  return etsi_its_denm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_msgs::msg::SituationContainer>()
{
  return "etsi_its_denm_msgs::msg::SituationContainer";
}

template<>
inline const char * name<etsi_its_denm_msgs::msg::SituationContainer>()
{
  return "etsi_its_denm_msgs/msg/SituationContainer";
}

template<>
struct has_fixed_size<etsi_its_denm_msgs::msg::SituationContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_msgs::msg::CauseCode>::value && has_fixed_size<etsi_its_denm_msgs::msg::EventHistory>::value && has_fixed_size<etsi_its_denm_msgs::msg::InformationQuality>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_msgs::msg::SituationContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_msgs::msg::CauseCode>::value && has_bounded_size<etsi_its_denm_msgs::msg::EventHistory>::value && has_bounded_size<etsi_its_denm_msgs::msg::InformationQuality>::value> {};

template<>
struct is_message<etsi_its_denm_msgs::msg::SituationContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__SITUATION_CONTAINER__TRAITS_HPP_
