// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_msgs:msg/ValidityDuration.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__VALIDITY_DURATION__STRUCT_HPP_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__VALIDITY_DURATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_msgs__msg__ValidityDuration __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_msgs__msg__ValidityDuration __declspec(deprecated)
#endif

namespace etsi_its_denm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ValidityDuration_
{
  using Type = ValidityDuration_<ContainerAllocator>;

  explicit ValidityDuration_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0ul;
    }
  }

  explicit ValidityDuration_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0ul;
    }
  }

  // field types and members
  using _value_type =
    uint32_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint32_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint32_t MIN =
    0u;
  static constexpr uint32_t MAX =
    86400u;
  static constexpr uint32_t TIME_OF_DETECTION =
    0u;
  static constexpr uint32_t ONE_SECOND_AFTER_DETECTION =
    1u;

  // pointer types
  using RawPtr =
    etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_msgs__msg__ValidityDuration
    std::shared_ptr<etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_msgs__msg__ValidityDuration
    std::shared_ptr<etsi_its_denm_msgs::msg::ValidityDuration_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ValidityDuration_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const ValidityDuration_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ValidityDuration_

// alias to use template instance with default allocator
using ValidityDuration =
  etsi_its_denm_msgs::msg::ValidityDuration_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ValidityDuration_<ContainerAllocator>::MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ValidityDuration_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ValidityDuration_<ContainerAllocator>::TIME_OF_DETECTION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint32_t ValidityDuration_<ContainerAllocator>::ONE_SECOND_AFTER_DETECTION;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_denm_msgs

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__VALIDITY_DURATION__STRUCT_HPP_
