// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_msgs:msg/RoadWorksContainerExtended.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_EXTENDED__STRUCT_H_
#define ETSI_ITS_DENM_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_EXTENDED__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'light_bar_siren_in_use'
#include "etsi_its_denm_msgs/msg/detail/light_bar_siren_in_use__struct.h"
// Member 'closed_lanes'
#include "etsi_its_denm_msgs/msg/detail/closed_lanes__struct.h"
// Member 'restriction'
#include "etsi_its_denm_msgs/msg/detail/restricted_types__struct.h"
// Member 'speed_limit'
#include "etsi_its_denm_msgs/msg/detail/speed_limit__struct.h"
// Member 'incident_indication'
#include "etsi_its_denm_msgs/msg/detail/cause_code__struct.h"
// Member 'recommended_path'
#include "etsi_its_denm_msgs/msg/detail/itinerary_path__struct.h"
// Member 'starting_point_speed_limit'
#include "etsi_its_denm_msgs/msg/detail/delta_reference_position__struct.h"
// Member 'traffic_flow_rule'
#include "etsi_its_denm_msgs/msg/detail/traffic_rule__struct.h"
// Member 'reference_denms'
#include "etsi_its_denm_msgs/msg/detail/reference_denms__struct.h"

/// Struct defined in msg/RoadWorksContainerExtended in the package etsi_its_denm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_msgs__msg__RoadWorksContainerExtended
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// RoadWorksContainerExtended ::= SEQUENCE {
  ///  lightBarSirenInUse LightBarSirenInUse OPTIONAL,
  ///  closedLanes ClosedLanes OPTIONAL,
  ///  restriction RestrictedTypes OPTIONAL,
  ///  speedLimit SpeedLimit OPTIONAL,
  ///  incidentIndication CauseCode OPTIONAL,
  ///  recommendedPath ItineraryPath OPTIONAL,
  ///  startingPointSpeedLimit DeltaReferencePosition OPTIONAL,
  ///  trafficFlowRule TrafficRule OPTIONAL,
  ///  referenceDenms ReferenceDenms OPTIONAL
  ///  }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_msgs__msg__LightBarSirenInUse light_bar_siren_in_use;
  bool light_bar_siren_in_use_is_present;
  etsi_its_denm_msgs__msg__ClosedLanes closed_lanes;
  bool closed_lanes_is_present;
  etsi_its_denm_msgs__msg__RestrictedTypes restriction;
  bool restriction_is_present;
  etsi_its_denm_msgs__msg__SpeedLimit speed_limit;
  bool speed_limit_is_present;
  etsi_its_denm_msgs__msg__CauseCode incident_indication;
  bool incident_indication_is_present;
  etsi_its_denm_msgs__msg__ItineraryPath recommended_path;
  bool recommended_path_is_present;
  etsi_its_denm_msgs__msg__DeltaReferencePosition starting_point_speed_limit;
  bool starting_point_speed_limit_is_present;
  etsi_its_denm_msgs__msg__TrafficRule traffic_flow_rule;
  bool traffic_flow_rule_is_present;
  etsi_its_denm_msgs__msg__ReferenceDenms reference_denms;
  bool reference_denms_is_present;
} etsi_its_denm_msgs__msg__RoadWorksContainerExtended;

// Struct for a sequence of etsi_its_denm_msgs__msg__RoadWorksContainerExtended.
typedef struct etsi_its_denm_msgs__msg__RoadWorksContainerExtended__Sequence
{
  etsi_its_denm_msgs__msg__RoadWorksContainerExtended * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_msgs__msg__RoadWorksContainerExtended__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_EXTENDED__STRUCT_H_
